IOWDB= {
	ginv = {ginv = true,
                guildinv = true,
                ginvite = true},
    inv = { inv = true,
               invite = true}
}
nameAndVersion = "InviteOnWhisper v"..GetAddOnMetadata("InviteOnWhisper", "Version")

local print = print
local BNGetFriendInfoByID = BNGetFriendInfoByID
local lower = lower
local trim = trim
local strlower = strlower
local _M = {}
IOWFunctions = _M

local IOW = CreateFrame("Frame", "InviteOnWhisper")

local function OnEvent(self, event, ...)
	local dispatch = self[event]

	if dispatch then
		dispatch(self, ...)
	end
end

IOW:SetScript("OnEvent", OnEvent)
IOW:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
IOW:RegisterEvent("ADDON_LOADED")
IOW:RegisterEvent("CHAT_MSG_BN_WHISPER")
IOW:RegisterEvent("CHAT_MSG_WHISPER")
--IOW:RegisterEvent("CHAT_MSG_GUILD")

function IOW:ADDON_LOADED(...)
    
    print("Loaded " .. nameAndVersion .. "; type '/iow info', for more info")
    
    StaticPopupDialogs["ginvPopup"] = {
        text = "Do you want to invite %s to your guild?",
        button1 = "Yes",
        button2 = "No",
        OnAccept = function(self, data)
            GuildInvite(data)
        end,
        OnCancel = function()
            --reply to whisper
            return
        end,
        timeout = 0,
        whileDead = true,
        hideOnEscape = true,
        preferredIndex = 3, 
    }
    
    self:UnregisterEvent("ADDON_LOADED")
end

function IOW:CHAT_MSG_BN_WHISPER(msg, _, _, _, _, _, _, _, _, _, _, _, bnetIDAccount,_)
    local _, _, _, _, charname, _ = BNGetFriendInfoByID(bnetIDAccount)
    _M.process_msg(msg, charname)
end

function IOW:CHAT_MSG_WHISPER(msg,charname,_)
    _M.process_msg(msg,charname)
end

function IOW:CHAT_MSG_GUILD(msg,charname,_)
    return
end


_M.process_msg = function(msg,charname)
    msg = msg:lower():trim()
    if IOWDB.ginv[msg] then
        --print("InviteOnWhisper - trying to invite" ..charname .." to your guild")
        
        local dialog = StaticPopup_Show("ginvPopup", charname)
        if (dialog) then
            dialog.data = charname
        end
    elseif IOWDB.inv[msg] then
        print("InviteOnWhisper - trying to invite" ..charname .." to your party/raid")
        InviteUnit(charname)
    end
end


_M.printInfo = function(subject)
    print(nameAndVersion)
    print("This addon is a work in progress!")
    print("If someone whispers you 'ginv', 'ginvite' or 'guildinv', they'll be invited to your guild if possible")
    print("If they whisper 'inv' or 'invite', they'll be invited to your party/raid")
end

SLASH_IOW1="/iow"
SlashCmdList["IOW"] =
	function(msg)
		local a1, a2, a3, a4, a5 = strsplit(" ", strlower(msg), 5)
        if (a1 == "") then 
            _M.printInfo()
        elseif (a1 == "info")  then 
            _M.printInfo(a2)
        end
    end   



